﻿using System;
using System.Web.UI;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
            Map1.CurrentExtent = new RectangleShape(-114.34, 75.27, 108.79, -70.23);
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            InMemoryFeatureLayer shapeLayer = new InMemoryFeatureLayer();
            shapeLayer.Name = "LinesShapeLayer";
            shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.StandardColors.Red, 2));
            shapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            InMemoryMarkerOverlay markerOverlay = new InMemoryMarkerOverlay("Markers");
            markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = new WebImage("target.gif", 15, 15);
            markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay shapeOverlay = new LayerOverlay("ShapeOverlay");
            shapeOverlay.Layers.Add("ShapeLayer", shapeLayer);

            Map1.CustomOverlays.Add(markerOverlay);
            Map1.CustomOverlays.Add(shapeOverlay);
        }
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        InMemoryMarkerOverlay markerOverlay = (InMemoryMarkerOverlay)Map1.CustomOverlays["Markers"];
        PointShape p1 = new PointShape(0, -60);
        PointShape p2 = new PointShape(100, 60);

        markerOverlay.Features.Add("P1", new Feature(p1));
        markerOverlay.Features.Add("P2", new Feature(p2));

        InMemoryFeatureLayer shapeLayer = (InMemoryFeatureLayer)((LayerOverlay)Map1.CustomOverlays["ShapeOverlay"]).Layers["ShapeLayer"];
        MultilineShape line = p1.GetShortestLineTo(p2, GeographyUnit.DecimalDegree);
        shapeLayer.InternalFeatures.Add("Distance", new Feature(line));

        ((LayerOverlay)Map1.CustomOverlays["ShapeOverlay"]).Redraw();
    }
}
